<template>
  <MglMarker
    :coordinates="coordinates"
    :key="`course-${value.id}`"
    ref="course"
  >
    <MglPopup :offset="[0, -15]">
      <div>
        <h4>{{ name || "Unnamed Course" }}</h4>
        <p v-if="description">{{ description }}</p>
        <p v-if="value.owners">by {{ value.owners.nodes[0].user.name }}</p>
        <el-button @click="$router.push(`/run/course?id=` + id)">Run</el-button>
        <el-button
          v-if="value.writeable"
          @click="$router.push(`/courses/${id}/edit`)"
          >Edit</el-button
        >
        <el-button v-else @click="$router.push(`/courses/${id}/`)"
          >View</el-button
        >
        <el-button
          v-if="value.printConfig"
          @click="$router.push(`/print/${id}`)"
          >Print</el-button
        >
      </div>
    </MglPopup>
    <div
      slot="marker"
      class="marker"
      v-if="value.owners && value.owners.nodes[0].user.avatarUrl"
    >
      <img :src="value.owners.nodes[0].user.avatarUrl" />
    </div>
  </MglMarker>
</template>
<style lang="scss" scoped>
@import "~assets/mixins";

.marker {
  max-width: $grid;
  max-height: $grid;
  border: gray 1px solid;
  border-radius: $grid;
  overflow: hidden;

  img {
    width: $grid;
    height: $grid;
  }
}
</style>
<script>
import { get } from "~/lib/utils";

export default {
  props: ["value"],
  computed: {
    coordinates() {
      const cp =
        get(this.value, "startCheckpoint") ||
        get(this.value, "checkpoints.nodes.0");

      if (cp) {
        return [Number(cp.lng), Number(cp.lat)];
      }
      return null;
    },
    id() {
      return get(this.value, "id");
    },
    name() {
      return get(this.value, "name");
    },
    description() {
      return get(this.value, "description");
    },
  },
};
</script>
